;+
;FUNCTION splfunc
;USAGE:
;  param = splfunc(x_old,y_old)
;  y = splfunc(x_new,param=p)
;-

function splfunc, xs,ys, param=p,xlog=xlog,ylog=ylog

xl = keyword_set(xlog)
yl = keyword_set(ylog)


if not keyword_set(p) then begin 
   xps = float(xl ? alog10(xs) : xs)
   yps = double(yl ? alog10(ys) : ys)
   s = sort(xps)
   xps=xps[s]
   yps=yps[s]
   interp_gap,xps,yps
   p = {func:'splfunc', x: xps,  y: yps, xlog:xl, ylog:yl}
   return,p
endif

ys2 = spl_init(p.x,p.y)
f = spl_interp(p.x,p.y,ys2,p.xlog ? alog10(xs) : xs)


return, p.ylog ? 10.^f : f
end


