pro ea_plot,dat,erange=erange,frange=frange,elog=elog,plts=plts, $
  cpd=cpd,npa=npa, $
  linestyle=linestyle

add_magf,dat,'wi_B3'
add_vsw,dat,'Vp'
pd=pad(convert_vframe(dat,/int),num_pa=npa)

pos = plot_positions(ysize=[3,1],ygap=3,xsize=[3,1],xgap=4)

if n_elements(elog) eq 0 then elog =1
if n_elements(psym) eq 0 then psym=-4

;if not keyword_set(erange) then erange=roundsig(minmax(pd.energy)*[.9,1.1],sig=0.)
if not keyword_set(erange) then erange= elog ? [5.,1500.]: [0,1200.] 
;if not keyword_set(frange) then frange=roundsig(minmax(pd.data)*[.8,1.2],sig=0.)
if not keyword_set(frange) then frange=[1e-18,5e-10]
if not keyword_set(arange) then arange=[0,180.]
flog =1

if keyword_set(plts) then restore_plot_state,plts[0]  else begin
  plot,[0],/nodata,pos=pos[*,0],yrange=frange,xrange=erange,ylog=flog,xlog=elog,/xstyle,/ystyle
  plt1=get_plot_state()
endelse

col = bytescale(findgen(pd.nbins))
for i=0,pd.nbins-1 do $
 oplot,pd.energy[*,i],pd.data[*,i],psym=psym,col=col[i]


if keyword_set(plts) then restore_plot_state,plts[1]  else begin
  plot,[0],/nodata,/noerase,pos=pos[*,1],  $
    xrange=arange,yrange=frange,xlog=0,ylog=flog, $
    /xstyle,/ystyle, $
    ytickname=replicate(' ',30), $
    xtickv=[0,90,180.],xticks=3,xminor=9
  plt2=get_plot_state()
endelse

col = bytescale(findgen(pd.nenergy))
for i=0,pd.nenergy-1 do $
 oplot,pd.angles[i,*],pd.data[i,*],psym=psym,col=col[i]




if keyword_set(plts) then restore_plot_state,plts[2]  else begin
  plot,[0],/nodata,/noerase,pos=pos[*,2],  $
    yrange=arange,xrange=erange,ylog=0,xlog=elog, $
    /xstyle,/ystyle, $
    ytickv=[0,90,180.],yticks=3,yminor=9
  plt3=get_plot_state()
  plts=[plt1,plt2,plt3]
endelse

mass=pd.mass
dfpar = distfunc(pd,df=pd.data)
n_a = 19
n_e = 25
ang = dgen(n_a,/y)
nrg = dgen(n_e,/x)
f= distfunc(nrg # replicate(1,n_a),replicate(1,n_e) #ang,param=dfpar,mass=mass)
if not keyword_set(cpd) then cpd = 2
mmf = round(alog10(minmax(f))*cpd)
nl = mmf[1]-mmf[0]+1
levels = (findgen(nl)+mmf[0])/cpd
;print,levels
c_label = abs(levels mod 1) le .001
;print,c_label
c_col = (get_colors('mbcgyr'))[floor(-levels) mod 6]
;c_col = bytescale(levels mod 10)
contour,alog10(f),nrg,ang,/over,levels=levels,c_label=c_label,c_col=c_col




end



