;+
;PROCEDURE:  clim , struct, min, max, type
;PURPOSE:    adds the tag 'zrange' to the structure "struct"
;	     this can then be used by "bytescale"
;	     to scale colors
;INPUTS: 
;   struct:  structure to be added to.  (Created if non-existent)
;      If struct is a string then the limits structure associated with that
;      string is used instead.
;   min:     min value of yrange
;   max:     max value of yrange
;   type:    type of color scale, 1 = log, 0 = linear
;Typical usage:
;   clim,lim,-20,100
;
;CREATED BY:	Jasper Halekas
;LAST MODIFICATION:	@(#)clim.pro	1.3 95/10/06
;-
pro clim,struct,min,max, type


if n_elements(max) eq 0 then range = [0.,0.] else range = float([min,max])
options,struct,'zrange',range
if n_elements(type) eq 0 then type = 0
options,struct,'log_color',type


return
end

