;+
;PROCEDURE:	make_any_plot
;PURPOSE:	make summary plots in gif format
;INPUT:		none
;KEYWORDS:	dates:  array of date strings
;		ps:	if set makes postscript instead of gif file
;
;CREATED BY:	Jasper Halekas
;LAST MODIFICATION:	@(#)make_any_plot.pro	1.4 95/11/20
;-

pro make_any_plot, dates = dates, ps = ps

psdir = '/disks/aeolus/home/wind/www/plots/'
gifdir = '/disks/aeolus/home/wind/www/plots/'

if not keyword_set(dates) then dates = get_latest_dates()

s = dimen1(dates)

for i = 0, s-1 do begin
	load_3dp_data, dates(i)
	get_emom
	get_spec,'eh'
	get_spec,'el'
	get_pmom
	get_spec,'ph'
	get_spec,'pl'
	if keyword_set(ps) then begin
		
		popen, psdir+dates(i)+'_eesa'
		tplot, ['Ne', 'Ve', 'Te', 'ehspec','elspec']
		pclose, printer = 'wp1'
		
		popen, psdir+dates(i)+'_pesa'
		tplot, ['Np', 'Vp', 'Tp', 'phspec','plspec']
		pclose, printer = 'wp1'
		
	endif 
		
	window,0,/pixmap,xsize=640,ysize=512

	tplot, ['Ne', 'Ve', 'Te', 'ehspec','elspec']
	t = tvrd()
	write_gif,gifdir+dates(i)+'_eesa.gif', t
	
	tplot, ['Np', 'Vp', 'Tp', 'phspec','plspec']
	t = tvrd()
	write_gif,gifdir+dates(i)+'_pesa.gif', t
	
endfor

return 
end
