;+
;PROCEDURE: 	movie_3d
;PURPOSE:	to store and animate 3dplots of data
;INPUT:		
;	data_name:	A string such as 'el' or 'so' that tells what kind
;			of data to animate
;			It is assumed that 
;			"load_3dp_data" has already 
;			been called to load WIND data.	
;KEYWORDS
;	starttime:	time to start at, otherwise at first sample in data
;	frames:		number of frames to animate, default is 10
;	smooth:		smoothing parameter for plot3d
;	bins:		array of which bins plot3d is to plot
;	start,stop:	arrays of starting and ending energy steps for each plot
;
;SEE ALSO:	"plot3d", which is the procedure that plots
;		each frame of movie_3d's movies.
;
;CREATED BY:	Jasper Halekas
;LAST MODIFICATION:	@(#)movie_3d.pro	1.6 95/10/06
;-

pro movie_3d, data_name, starttime = starttime, frames = frames, bins = bins, $
 smooth = smooth, start = start, stop = stop

if not keyword_set(frames) then frames = 10

procedure = 'get_'+data_name

xinteranimate, set = [640,512, frames]

if keyword_set(starttime) then t = gettime(starttime)

for i = 0, frames -1 do begin
	dat = call_function (procedure, t)
	if i eq 0 then plot3d,dat,/save,bins=bins,smooth=smooth,start=start, $
	stop=stop  else $
	plot3d,dat, bins = bins, smooth = smooth, start = start, stop = stop
	xinteranimate, frame = i , window = !d.window
end

xinteranimate, 1

@plot3d_com
zrange_3d = replicate(0.,30,2)

return 
end
