;+
;PROCEDURE: sym.pro
;PURPOSE: ASSIGN USERSYM WITH SYMBOL
;
;USAGE: SYM, PSYM = PSYM,SYMSIZE = SYMSIZE,NOFILL=NOFILL,_EXTRA=E
;
; PSYM:
;    1 = CIRCLE
;    4 = DIAMOND
;    5 = TRIANGLE
;    6 = SQUARE
;
;-
;==============================================================================
PRO SYM, PSYM = PSYM,SYMSIZE = SYMSIZE,NOFILL=NOFILL,_EXTRA=E

IF NOT KEYWORD_SET(PSYM) THEN PSYM = 1 ;DEFAULT CIRCLES
IF NOT KEYWORD_SET(SYMSIZE) THEN SYMSIZE = 1 ;DEFAULT SYMBOL SIZE

CASE PSYM OF
    1: A = FINDGEN(40)*2D0*!PI/40D0 ;CIRCLE
    4: A = FINDGEN(5)*2D0*!PI/4D0 ;DIAMOND
    5: A = FINDGEN(4)*2D0*!PI/3D0 + !PI/2. ;TRIANGLE
    6: A = FINDGEN(5)*2D0*!PI/4D0+!PI/4. ;SQUARE
ELSE: BEGIN
    PRINT, ''
    PRINT, 'INVALID SYMSEL'
    PRINT, ''
    RETURN
END
ENDCASE


IF NOT KEYWORD_SET(NOFILL) THEN USERSYM,SYMSIZE*COS(A),SYMSIZE*SIN(A),/FILL,_EXTRA=E $
ELSE USERSYM,SYMSIZE*COS(A),SYMSIZE*SIN(A),_EXTRA=E

RETURN
END
