;+
;PROCEDURE:	get_orbit_label_gsm
;PURPOSE:	Gets orbital data and creates the plot label quantities:
;                      'R','LT', and 'LAT' for use in tplot 
;INPUT:		none at the moment
;KEYWORDS:	none at the moment
;
;Example:	
;	get_orbit_label
;	tplot,['Np','Ne','Tp'],var_label=['R','LT','LAT']  
;   
;CREATED BY:	Tai Phan
;VERSION: @(#)get_orbit_label.pro	1.0
;LAST MODIFICATION: 95/09/06
;-

pro get_orbit_label_gsm

get_orbit_gsm,predicted=1


get_data,'GSM_pos_pre',data=d
time= d.x
r = sqrt(total(d.y^2,2))
phi = atan(d.y(*,1),d.y(*,0))/!dtor
xlt = 12. + phi/15.
lat= atan(d.y(*,2),sqrt(d.y(*,0)^2+d.y(*,1)^2))/!dtor

store_data,'Xgsm',data={ytitle:'Xgsm',xtitle:'Time',x:time,y:d.y(*,0)}
store_data,'Ygsm',data={ytitle:'Ygsm',xtitle:'Time',x:time,y:d.y(*,1)}
store_data,'Zgsm',data={ytitle:'Zgsm',xtitle:'Time',x:time,y:d.y(*,2)}

r= {ytitle:'R',xtitle:'Time',x:time,y:r}
store_data,'R', data=r

xlt= {ytitle:'LT',xtitle:'Time',x:time,y:xlt}
store_data,'LT', data=xlt

lat= {ytitle:'LAT',xtitle:'Time',x:time,y:lat}
store_data,'LAT', data=lat 


return
end



