pro read_imp8_pla,date

spawn,'cat /disks/chinook/disk1/phan/wind/imp8/imp8_'+date+'.dat | wc -l',lines

numpt=long(lines(0))

a= fltarr(20,numpt)

yr=1
day=2
hr=3
min=4
sec=5
xgse=7
ygse=8
zgse=9
ygsm=10
zgsm=11
speed=12
vx=13
vy=14
vz=15
vth=16
np=17

openr,u,'/disks/chinook/disk1/phan/wind/imp8/imp8_'+date+'.dat',/get_lun

readf,u,a

close,u

a=transpose(a)

s= time_struct(date)

time_i8_pla= a(*,hr)*3600.+a(*,min)*60.+a(*,sec)+str_to_time(date+'/0:')

for i=-3,3 do begin

next=where(a(*,day) eq s.doy+i,nnext)

if nnext ne 0 then time_i8_pla(next)=time_i8_pla(next)+(i*24.*3600.)

endfor


sc_pos_i8_gse= reform(a(*,7:9))
speed_i8= a(*,speed)
vx_i8=a(*,vx)
vy_i8=a(*,vy)
vz_i8=a(*,vz)
v_i8=a(*,13:15)
vth_i8=a(*,vth)
np_i8=a(*,np)
vmag_i8=sqrt(vx_i8^2 + vy_i8^2 + vz_i8^2)

store_data,'imp8',data={x:time_i8_pla,speed:speed_i8,vx:vx_i8,vy:vy_i8,$
	vz:vz_i8,vth:vth_i8,np:np_i8}
	
store_data,'Sc_pos_i8',data={x:time_i8_pla,y:sc_pos_i8_gse,ytitle:'IMP8 Pos'}
store_data,'n_i8',data={x:time_i8_pla,y:np_i8,ytitle:'IMP8 Dens'}
store_data,'vx_i8',data={x:time_i8_pla,y:vx_i8,ytitle:'IMP8 vx'}
store_data,'v_i8',data={x:time_i8_pla,y:v_i8,ytitle:'IMP8 v'}
store_data,'vy_i8',data={x:time_i8_pla,y:vy_i8,ytitle:'IMP8 vy'}
store_data,'vz_i8',data={x:time_i8_pla,y:vz_i8,ytitle:'IMP8 vz'}
store_data,'vmag_i8',data={x:time_i8_pla,y:vmag_i8,ytitle:'IMP8 Vmag'}
store_data,'vth_i8',data={x:time_i8_pla,y:vth_i8,ytitle:'IMP8 vth'}

sc_pos_i8_gse={x:time_i8_pla,y:sc_pos_i8_gse,ytitle:'IM8 Pos'}
n_i8={x:time_i8_pla,y:np_i8,ytitle:'IMP8 Dens'}
vx_i8={x:time_i8_pla,y:vx_i8,ytitle:'IMP8 vx'}
vy_i8={x:time_i8_pla,y:vy_i8,ytitle:'IMP8 vy'}
vz_i8={x:time_i8_pla,y:vz_i8,ytitle:'IMP8 vz'}
vmag_i8={x:time_i8_pla,y:vmag_i8,ytitle:'IMP8 Vmag'}

t=time_i8_pla

;save,t,n_i8,vx_i8,vy_i8,vz_i8,vmag_i8,sc_pos_i8_gse,file='imp8_vars_'+date+'.dat'

return

end
